#ifndef VED_RTE_WRAPPER_H
#define VED_RTE_WRAPPER_H

// Reza changed
// #include "Time.h"

// Reza Added
#include "time_handler.h"
#include "ved_ext.h"

#ifdef __cplusplus
extern "C"
{
#endif


	void VED_StepExec(void);
	void VED_Initialize(void);
	static void VED_RTE_InputWrapper(void);
	static void VED_RTE_OutputWrapper(void);
	reqVEDPrtList_t *p_VED_in(void);
	proVEDPrtList_t *p_VED_out(void);
	reqVEDParams_t *p_VED_params(void);
// #include "lbs_main.h"
#include "bsw_pc_stub.h"
// RENDL add for Wrapper interface with RTE interface
/**********************************************************************************************************************
 * Rte_Read_<p>_<d> (explicit S/R communication with isQueued = false)
 *********************************************************************************************************************/
#define Rte_Read_ST_VED_CANIn_ST_VED_CANIn
#define Rte_Read_ST_VEDNvIoDatas_Read_t_ST_VEDNvIoDatas_Read_t										Rte_Read_rNVRAM_ST_VEDNvIoDatas_t_ST_VEDNvIoDatas_t

#define Rte_Read_ST_VED_NVRAMData_ReceiveFlag_ST_VED_NVRAMData_ReceiveFlag
#define Rte_Read_ST_CarConfigParamOut_ST_CarConfigParamOut

// CAN mapping
#define Rte_Read_IDB_Fr03_Timestamp_IDB_Fr03_Timestamp
#define Rte_Read_BCS_YawRate_BCS_YawRate															Rte_Read_rSWCRX_BCS_YawRate_BCS_YawRate
#define Rte_Read_EPS_SteeringAngle_EPS_SteeringAngle												Rte_Read_rSWCRX_EPS_SteeringAngle_EPS_SteeringAngle
#define Rte_Read_BCS_ActVehLaltrlAccel_BCS_ActVehLaltrlAccel										Rte_Read_rSWCRX_BCS_ActVehLaltrlAccel_BCS_ActVehLaltrlAccel
#define Rte_Read_BCS_FLWheelSpd_BCS_FLWheelSpd														Rte_Read_rSWCRX_BCS_FLWheelSpd_BCS_FLWheelSpd
#define Rte_Read_BCS_FRWheelSpd_BCS_FRWheelSpd														Rte_Read_rSWCRX_BCS_FRWheelSpd_BCS_FRWheelSpd
#define Rte_Read_BCS_RLWheelSpd_BCS_RLWheelSpd														Rte_Read_rSWCRX_BCS_RLWheelSpd_BCS_RLWheelSpd
#define Rte_Read_BCS_RRWheelSpd_BCS_RRWheelSpd														Rte_Read_rSWCRX_BCS_RRWheelSpd_BCS_RRWheelSpd
#define Rte_Read_BCS_VehSpd_BCS_VehSpd																Rte_Read_rSWCRX_BCS_VehSpd_BCS_VehSpd
#define Rte_Read_BCS_ActVehLongAccel_BCS_ActVehLongAccel											Rte_Read_rSWCRX_BCS_ActVehLongAccel_BCS_ActVehLongAccel
#define Rte_Read_BCS_FLWheelRotatedDirection_BCS_FLWheelRotatedDirection							Rte_Read_rSWCRX_BCS_FLWheelRotatedDirection_BCS_FLWheelRotatedDirection
#define Rte_Read_BCS_FRWheelRotatedDirection_BCS_FRWheelRotatedDirection							Rte_Read_rSWCRX_BCS_FRWheelRotatedDirection_BCS_FRWheelRotatedDirection
#define Rte_Read_BCS_RLWheelRotatedDirection_BCS_RLWheelRotatedDirection                            Rte_Read_rSWCRX_BCS_RLWheelRotatedDirection_BCS_RLWheelRotatedDirection
#define Rte_Read_BCS_RRWheelRotatedDirection_BCS_RRWheelRotatedDirection                            Rte_Read_rSWCRX_BCS_RRWheelRotatedDirection_BCS_RRWheelRotatedDirection
#define Rte_Read_BCS_FLWheelSpdEdgesSum_BCS_FLWheelSpdEdgesSum                                		Rte_Read_rSWCRX_BCS_FLWheelSpdEdgesSum_BCS_FLWheelSpdEdgesSum
#define Rte_Read_BCS_FRWheelSpdEdgesSum_BCS_FRWheelSpdEdgesSum                                		Rte_Read_rSWCRX_BCS_FRWheelSpdEdgesSum_BCS_FRWheelSpdEdgesSum
#define Rte_Read_BCS_RLWheelSpdEdgesSum_BCS_RLWheelSpdEdgesSum                                		Rte_Read_rSWCRX_BCS_RLWheelSpdEdgesSum_BCS_RLWheelSpdEdgesSum
#define Rte_Read_BCS_RRWheelSpdEdgesSum_BCS_RRWheelSpdEdgesSum                                		Rte_Read_rSWCRX_BCS_RRWheelSpdEdgesSum_BCS_RRWheelSpdEdgesSum
#define Rte_Read_VCU_CrntGearLvl_VCU_CrntGearLvl                                        			Rte_Read_rSWCRX_VCU_CrntGearLvl_VCU_CrntGearLvl
#define Rte_Read_EPB_SysSt_EPB_SysSt                                    							Rte_Read_rSWCRX_EPB_SysSt_EPB_SysSt
#define Rte_Read_BCS_VehicleStandStillSt_BCS_VehicleStandStillSt                      				Rte_Read_rSWCRX_BCS_VehicleStandStillSt_BCS_VehicleStandStillSt
#define Rte_Read_EPS_SteeringAngleSpd_EPS_SteeringAngleSpd                            				Rte_Read_rSWCRX_EPS_SteeringAngleSpd_EPS_SteeringAngleSpd
#define Rte_Read_BCS_YawRateSt_BCS_YawRateSt                  										/*HERE*/ //Rte_Read_rSWCRX_ACU2_BCS_YawRateSt_BCS_YawRateSt
#define Rte_Read_EPS_SteeringAngleVD_EPS_SteeringAngleVD                 						 	Rte_Read_rSWCRX_EPS_SteeringAngleVD_EPS_SteeringAngleVD
#define Rte_Read_BCS_ActVehLaltrlAccelVD_BCS_ActVehLaltrlAccelVD                 					Rte_Read_rSWCRX_BCS_ActVehLaltrlAccelVD_BCS_ActVehLaltrlAccelVD
#define Rte_Read_BCS_FLWheelSpdVD_BCS_FLWheelSpdVD                  								Rte_Read_rSWCRX_BCS_FLWheelSpdVD_BCS_FLWheelSpdVD
#define Rte_Read_BCS_FRWheelSpdVD_BCS_FRWheelSpdVD                  								Rte_Read_rSWCRX_BCS_FRWheelSpdVD_BCS_FRWheelSpdVD
#define Rte_Read_BCS_RLWheelSpdVD_BCS_RLWheelSpdVD                  								Rte_Read_rSWCRX_BCS_RLWheelSpdVD_BCS_RLWheelSpdVD
#define Rte_Read_BCS_RRWheelSpdVD_BCS_RRWheelSpdVD                									Rte_Read_rSWCRX_BCS_RRWheelSpdVD_BCS_RRWheelSpdVD
#define Rte_Read_BCS_VehSpdVD_BCS_VehSpdVD                        									Rte_Read_rSWCRX_BCS_VehSpdVD_BCS_VehSpdVD
#define Rte_Read_BCS_ActVehLongAccelVD_BCS_ActVehLongAccelVD               							Rte_Read_rSWCRX_BCS_ActVehLongAccelVD_BCS_ActVehLongAccelVD
#define Rte_Read_BCS_FRWheelSpdEdgesSumVD_BCS_FRWheelSpdEdgesSumVD                      			Rte_Read_rSWCRX_BCS_FRWheelSpdEdgesSumVD_BCS_FRWheelSpdEdgesSumVD
#define Rte_Read_BCS_FLWheelSpdEdgesSumVD_BCS_FLWheelSpdEdgesSumVD                      			Rte_Read_rSWCRX_BCS_FLWheelSpdEdgesSumVD_BCS_FLWheelSpdEdgesSumVD
#define Rte_Read_BCS_RLWheelSpdEdgesSumVD_BCS_RLWheelSpdEdgesSumVD                      			Rte_Read_rSWCRX_BCS_RLWheelSpdEdgesSumVD_BCS_RLWheelSpdEdgesSumVD
#define Rte_Read_BCS_RRWheelSpdEdgesSumVD_BCS_RRWheelSpdEdgesSumVD                      			Rte_Read_rSWCRX_BCS_RRWheelSpdEdgesSumVD_BCS_RRWheelSpdEdgesSumVD
#define Rte_Read_VCU_CrntGearLvlVD_VCU_CrntGearLvlVD                              					Rte_Read_rSWCRX_VCU_CrntGearLvlVD_VCU_CrntGearLvlVD
#define Rte_Read_EPB_SysSt_EPB_SysSt                              									Rte_Read_rSWCRX_EPB_SysSt_EPB_SysSt
#define Rte_Read_EPS_SteeringAngleSpdVD_EPS_SteeringAngleSpdVD                  					Rte_Read_rSWCRX_EPS_SteeringAngleSpdVD_EPS_SteeringAngleSpdVD
#define Rte_Read_HVAC_CorrectedExterTempVD_HVAC_CorrectedExterTempVD            					Rte_Read_rSWCRX_HVAC_CorrectedExterTempVD_HVAC_CorrectedExterTempVD
#define Rte_Read_VCU_EMS_AccPedalActPstVD_VCU_EMS_AccPedalActPstVD                  				Rte_Read_rSWCRX_VCU_EMS_AccPedalActPstVD_VCU_EMS_AccPedalActPstVD
#define Rte_Read_VCU_EMS_BrkPedalStVD_VCU_EMS_BrkPedalStVD                 							Rte_Read_rSWCRX_VCU_EMS_BrkPedalStVD_VCU_EMS_BrkPedalStVD
#define Rte_Read_ICM_DisFail_ICM_DisFail          													Rte_Read_rSWCRX_ICM_DisFail_ICM_DisFail
#define Rte_Read_EPS_StrngWhlTorqVD_EPS_StrngWhlTorqVD            									Rte_Read_rSWCRX_EPS_StrngWhlTorqVD_EPS_StrngWhlTorqVD
#define Rte_Read_CS1_GearPositionReqStValid_ADCS_FD3_CS1_GearPositionReqStValid_ADCS_FD3            Rte_Read_rSWCRX_CS1_GearPositionReqStValid_CS1_GearPositionReqStValid
// #define Rte_Read_EPS2_MotCntrlValid_ADCS_FD3_EPS2_MotCntrlValid_ADCS_FD3                            Rte_Read_rSWCRX_EPS2_MotCntrlValid_EPS2_MotCntrlValid
#define Rte_Read_HVAC_CorrectedExterTemp_HVAC_CorrectedExterTemp                      				Rte_Read_rSWCRX_HVAC_CorrectedExterTemp_HVAC_CorrectedExterTemp
// #define Rte_Read_CS1_FrontWiperMISTReqSt_ADCS_FD3_CS1_FrontWiperMISTReqSt_ADCS_FD3                  Rte_Read_rSWCRX_CS1_FrontWiperMISTReqSt_CS1_FrontWiperMISTReqSt
#define Rte_Read_BCM_FrontWiperSt_BCM_FrontWiperSt                          						Rte_Read_rSWCRX_BCM_FrontWiperSt_BCM_FrontWiperSt
#define Rte_Read_BCM_FrontWasherSt_BCM_FrontWasherSt                  								Rte_Read_rSWCRX_BCM_FrontWasherSt_BCM_FrontWasherSt
#define Rte_Read_BCM_TurnLightSwitchSt_BCM_TurnLightSwitchSt                            			Rte_Read_rSWCRX_BCM_TurnLightSwitchSt_BCM_TurnLightSwitchSt
#define Rte_Read_BCM_FrontFogLampSt_BCM_FrontFogLampSt                        						Rte_Read_rSWCRX_BCM_FrontFogLampSt_BCM_FrontFogLampSt
#define Rte_Read_BCM_RearFogLampSt_BCM_RearFogLampSt                          						Rte_Read_rSWCRX_BCM_RearFogLampSt_BCM_RearFogLampSt
#define Rte_Read_ICM_TotalOdometer_ICM_TotalOdometer                                    			Rte_Read_rSWCRX_ICM_TotalOdometer_ICM_TotalOdometer
#define Rte_Read_VCU_EMS_AccPedalActPst_VCU_EMS_AccPedalActPst                          			Rte_Read_rSWCRX_VCU_EMS_AccPedalActPst_VCU_EMS_AccPedalActPst
#define Rte_Read_VCU_EMS_BrkPedalSt_VCU_EMS_BrkPedalSt                    							Rte_Read_rSWCRX_VCU_EMS_BrkPedalSt_VCU_EMS_BrkPedalSt
#define Rte_Read_DMS_FatigWarnSt_DMS_FatigWarnSt                  									Rte_Read_rSWCRX_DMS_FatigWarnSt_DMS_FatigWarnSt
#define Rte_Read_ICM_VehInsSpd_ICM_VehInsSpd                    									Rte_Read_rSWCRX_ICM_VehInsSpd_ICM_VehInsSpd
#define Rte_Read_BCM_KeySt_BCM_KeySt                                  								Rte_Read_rSWCRX_BCM_KeySt_BCM_KeySt
#define Rte_Read_SRS_DriverSeatBeltSt_SRS_DriverSeatBeltSt                            				Rte_Read_rSWCRX_SRS_DriverSeatBeltSt_SRS_DriverSeatBeltSt
#define Rte_Read_BCM_LowBeamSt_BCM_LowBeamSt                                  						Rte_Read_rSWCRX_BCM_LowBeamSt_BCM_LowBeamSt
#define Rte_Read_BCM_HighBeamSt_BCM_HighBeamSt                                						Rte_Read_rSWCRX_BCM_HighBeamSt_BCM_HighBeamSt
#define Rte_Read_BCM_HazardLampSt_BCM_HazardLampSt                            						Rte_Read_rSWCRX_BCM_HazardLampSt_BCM_HazardLampSt
// #define Rte_Read_BDCS1_FrontLampSt_ADCS_FD3_BDCS1_FrontLampSt_ADCS_FD3                              Rte_Read_rSWCRX_BDCS1_FrontLampSt_BDCS1_FrontLampSt
// #define Rte_Read_CDCS11_VoiceMode_ADCS_FD3_CDCS11_VoiceMode_ADCS_FD3                                Rte_Read_rSWCRX_CDCS11_VoiceMode_CDCS11_VoiceMode
// #define Rte_Read_CDCS11_ADAS_SndCtrlOnOff_ADCS_FD3_CDCS11_ADAS_SndCtrlOnOff_ADCS_FD3                Rte_Read_rSWCRX_CDCS11_ADAS_SndCtrlOnOff_CDCS11_ADAS_SndCtrlOnOff
#define Rte_Read_EPS_StrngWhlTorq_EPS_StrngWhlTorq                      							Rte_Read_rSWCRX_EPS_StrngWhlTorq_EPS_StrngWhlTorq
#define Rte_Read_CS1_GearPositionReqSt_ADCS_FD3_CS1_GearPositionReqSt_ADCS_FD3                      Rte_Read_rSWCRX_CS1_GearPositionReqSt_CS1_GearPositionReqSt
//#define Rte_Read_EPS_SteeringModeSt_EPS_SteeringModeSt                         						Rte_Read_rSWCRX_EPS_SteeringModeSt_EPS_SteeringModeSt
// #define Rte_Read_EPS_AssistPraSwitchToLKA_EPS_AssistPraSwitchToLKA                                	Rte_Read_rSWCRX_EPS_AssistPraSwitchToLKA_EPS_AssistPraSwitchToLKA
#define Rte_Read_VCU_ActVehWheelTorq_VCU_ActVehWheelTorq                                      		Rte_Read_rSWCRX_VCU_ActVehWheelTorq_VCU_ActVehWheelTorq
#define Rte_Read_EPS_LKACtrlAbortFeedback_EPS_LKACtrlAbortFeedback          						Rte_Read_rSWCRX_EPS_LKACtrlAbortFeedback_EPS_LKACtrlAbortFeedback
#define Rte_Read_BCM_DriverDoorAjarSt_BCM_DriverDoorAjarSt                                			Rte_Read_rSWCRX_BCM_DriverDoorAjarSt_BCM_DriverDoorAjarSt
#define Rte_Read_BCM_RLDoorAjarSt_BCM_RLDoorAjarSt                                					Rte_Read_rSWCRX_BCM_RLDoorAjarSt_BCM_RLDoorAjarSt
#define Rte_Read_BCM_PsngrDoorAjarSt_BCM_PsngrDoorAjarSt                                			Rte_Read_rSWCRX_BCM_PsngrDoorAjarSt_BCM_PsngrDoorAjarSt
#define Rte_Read_BCM_RRDoorAjarSt_BCM_RRDoorAjarSt                                					Rte_Read_rSWCRX_BCM_RRDoorAjarSt_BCM_RRDoorAjarSt
// #define Rte_Read_BDCS1_TrunkLockSts_ADCS_FD3_BDCS1_TrunkLockSts_ADCS_FD3                            Rte_Read_rSWCRX_BDCS1_TrunkLockSts_BDCS1_TrunkLockSts
// #define Rte_Read_BDCS1_HoodAjarSts_ADCS_FD3_BDCS1_HoodAjarSts_ADCS_FD3                              Rte_Read_rSWCRX_BDCS1_HoodAjarSts_BDCS1_HoodAjarSts
// #define Rte_Read_CDCS5_ResetAllSetup_ADCS_FD3_CDCS5_ResetAllSetup_ADCS_FD3                          Rte_Read_rSWCRX_CDCS5_ResetAllSetup_CDCS5_ResetAllSetup
// #define Rte_Read_CDCS5_FactoryReset_ADCS_FD3_CDCS5_FactoryReset_ADCS_FD3                            Rte_Read_rSWCRX_CDCS5_FactoryReset_CDCS5_FactoryReset
#define Rte_Read_VCU5_ActGearValid_ADCS_FD3_VCU5_ActGearValid_ADCS_FD3                              Rte_Read_rSWCRX_VCU5_ActGearValid_VCU5_ActGearValid
#define Rte_Read_CS1_GearPositionReqStValid_ADCS_FD3_CS1_GearPositionReqStValid_ADCS_FD3            Rte_Read_rSWCRX_CS1_GearPositionReqStValid_CS1_GearPositionReqStValid
#define Rte_Read_BCS_ABSActiveSt_BCS_ABSActiveSt                                   					Rte_Read_rSWCRX_BCS_ABSActiveSt_BCS_ABSActiveSt
#define Rte_Read_BCS_TCSActiveSt_BCS_TCSActiveSt                                    				Rte_Read_rSWCRX_BCS_TCSActiveSt_BCS_TCSActiveSt
//#define Rte_Read_IDB7_ESCActive_ADCS_FD3_IDB7_ESCActive_ADCS_FD3                                    Rte_Read_rSWCRX_IDB7_ESCActive_IDB7_ESCActive
// #define Rte_Read_IDB7_ESCDisable_ADCS_FD3_IDB7_ESCDisable_ADCS_FD3                                  Rte_Read_rSWCRX_IDB7_ESCDisable_IDB7_ESCDisable
#define Rte_Read_BCS_TCSOff_BCS_TCSOff                                  							Rte_Read_rSWCRX_BCS_TCSOff_BCS_TCSOff
#define Rte_Read_BCS_AWBActive_BCS_AWBActive                                  						Rte_Read_rSWCRX_BCS_AWBActive_BCS_AWBActive
// #define Rte_Read_IDB5_Jerkfail_ADCS_FD3_IDB5_Jerkfail_ADCS_FD3                                      Rte_Read_rSWCRX_IDB5_Jerkfail_IDB5_Jerkfail
#define Rte_Read_BCS_AEBAvailable_BCS_AEBAvailable                                  				Rte_Read_rSWCRX_BCS_AEBAvailable_BCS_AEBAvailable
// #define Rte_Read_IDB1_FailedState_ADCS_FD3_IDB1_FailedState_ADCS_FD3                                Rte_Read_rSWCRX_IDB1_FailedState_IDB1_FailedState
#define Rte_Read_BCS_HDCCtrlSt_BCS_HDCCtrlSt                                						Rte_Read_rSWCRX_BCS_HDCCtrlSt_BCS_HDCCtrlSt
// #define Rte_Read_IDB7_ARPACTIVE_ADCS_FD3_IDB7_ARPACTIVE_ADCS_FD3
// #define Rte_Read_IDB7_ARPFailure_ADCS_FD3_IDB7_ARPFailure_ADCS_FD3
#define Rte_Read_ICM_VehInsSpd_ICM_VehInsSpd                                      Rte_Read_rSWCRX_ICM_VehInsSpd_ICM_VehInsSpd
/**********************************************************************************************************************
 * Rte_Write_<p>_<d> (explicit S/R communication with isQueued = false)
 *********************************************************************************************************************/
#define Rte_Write_ST_EMVEDVehPar_t_ST_EMVEDVehPar_t 												Rte_Write_pVED_ST_EMVEDVehPar_t_ST_EMVEDVehPar_t
#define Rte_Write_ST_VEDNvIoDatas_Write_t_ST_VEDNvIoDatas_Write_t 									Rte_Write_pVED_ST_VEDNvIoDatas_t_ST_VEDNvIoDatas_t
#define Rte_Write_ST_VEDVehDyn_t_ST_VEDVehDyn_t 													Rte_Write_pVED_ST_VEDVehDyn_t_ST_VEDVehDyn_t
#define Rte_Write_ST_VEDVehSig_t_ST_VEDVehSig_t 													Rte_Write_pVED_ST_VEDVehSig_t_ST_VEDVehSig_t
// #define Rte_Write_ST_VehicleDynamicSignals_t_ST_VehicleDynamicSignals_t  							

#define Rte_Write_ST_adcu_ved_dtc_ST_adcu_ved_dtc
#define R_IoHwAbs_System_Timer_Get_64bit_1usec_Current_Value(_ts)										(Time_GetTimeStampUs(_ts))

#ifdef __cplusplus
}
#endif
#endif
